#include "H8_register.h" /* H8/3067̃WX^ */
#include "RTL8019AS_register.h" /* RTL8019AS̃WX^ */
#include "packet_definition.h" /* pPbg̒` */
#include "global_variables.h" /* O[oϐ̒` */
#include "H8_register_function.h" /* H8/3067̃WX^̐ݒ */
#include "delay_function.h" /* ԑ҂̊֐ */
#include "LCD_function.h" /* SC1602B̊֐ */
#include "NIC_function.h" /* RTL8019AS̊֐ */
#include "matrix_key_function.h" /* }gNXEL[̊֐ */
#include "utility_function.h" /* ̂ق̊֐ */
#include "ARP_function.h" /* ARP̊֐ */
#include "ping_function.h" /* ping̊֐ */

void main(void)
{
   unsigned char packet_type;
   ARP_PACKET *arp_packet;
   PING_PACKET *ping_packet;
   
   H8_register_init(); /* H8/3067̃WX^̐ݒ */
   LCD_init(); /* SC1602B̏ */
   NIC_init(); /* RTL8019AS̏ */
   
   /* MIPAhX̐ݒ */
   src_IP[0] = 192;
   src_IP[1] = 168;
   src_IP[2] = 0;
   src_IP[3] = 100 + (P2DR & 0x07); /* fBbvEXCb`ɂđMIPAhXݒ肷 */
   
   LCD_clear(); /* \NA */
   LCD_control(0x80); /* J[\0sڂ̐擪Ɉړ */
   
   while (1) /* [v */
   {
      packet_type = 0; /* packet_type0ɂ */
      
      if (packet_receive(packet) != 1) /* pPbgMƂ */
      {
         arp_packet = (ARP_PACKET *)packet; /* packetARP_PACKET\̂ɓĂ͂߂ */
         if ((arp_packet -> eth_ethernet_type == 0x0806) && 
             /* ARP̃pPbĝƂ */
             (IP_compare(arp_packet -> arp_dst_IP, src_IP) == 0) && 
             /* pPbgɋLqĂ鈶IPAhXMIPAhXɈvƂ */
             (arp_packet -> arp_operation == 1)
             /* ARPNGXĝƂ */
            )
         {
            packet_type = 'a'; /* packet_type'a'ɂ */
         }
         
         ping_packet = (PING_PACKET *)packet; /* packetPING_PACKET\̂ɓĂ͂߂ */
         if ((ping_packet -> eth_ethernet_type == 0x0800) && 
             /* IP̃pPbĝƂ */
             (IP_compare(ping_packet -> ip_dst_IP, src_IP) == 0) && 
             /* pPbgɋLqĂ鈶IPAhXMIPAhXɈvƂ */
             (ping_packet -> ip_protocol == 1) && 
             /* ICMP̃pPbĝƂ */
             (ping_packet -> ping_type == 8)
             /* pingNGXĝƂ */
            )
         {
            packet_type = 'p'; /* packet_type'p'ɂ */
         }
      }
      
      switch (packet_type) /* packet_typeɂďs */
      {
         case 'a': /* packet_type'a'̂Ƃ */
            LCD_display(packet_type); /* tfBXvCpacket_type\ */
            ARP_reply(packet); /* ARPvC */
            break;
         case 'p': /* packet_type'p'̂Ƃ */
            LCD_display(packet_type); /* tfBXvCpacket_type\ */
            ping_reply(packet); /* pingvC */
            break;
      }
   }
}
